# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables

__all__ = ['UserContact']


class UserContact(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 method: Optional[pulumi.Input[str]] = None,
                 to: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Manages a User Contact.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_opsgenie as opsgenie

        sms = opsgenie.UserContact("sms",
            method="sms",
            to="39-123",
            username=opsgenie_user["exampleuser"]["username"])
        email = opsgenie.UserContact("email",
            method="email",
            to="fahri@opsgenie.com",
            username=opsgenie_user["exampleuser"]["username"])
        voice = opsgenie.UserContact("voice",
            method="voice",
            to="39-123",
            username=opsgenie_user["exampleuser"]["username"])
        ```

        ## Import

        Users can be imported using the `id`, e.g.

        ```sh
         $ pulumi import opsgenie:index/userContact:UserContact testcontact username/contactId`
        ```

         For this example- Username = `genie@awesometeam.com`

        - Contact Id = `2d1a78d0-c13e-47d3-af0a-8b6d0cc2b7b1`

        ```sh
         $ pulumi import opsgenie:index/userContact:UserContact testcontact genie@awesometeam.com/2d1a78d0-c13e-47d3-af0a-8b6d0cc2b7b1`
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enabled: Enable contact of the user in OpsGenie. Default value is true.
        :param pulumi.Input[str] method: This parameter is the contact method of user and should be one of email, sms or voice. Please note that adding mobile is not supported from API.
        :param pulumi.Input[str] to: to field is the address of given method.
        :param pulumi.Input[str] username: The username for contact.(reference)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['enabled'] = enabled
            if method is None and not opts.urn:
                raise TypeError("Missing required property 'method'")
            __props__['method'] = method
            if to is None and not opts.urn:
                raise TypeError("Missing required property 'to'")
            __props__['to'] = to
            if username is None and not opts.urn:
                raise TypeError("Missing required property 'username'")
            __props__['username'] = username
        super(UserContact, __self__).__init__(
            'opsgenie:index/userContact:UserContact',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            method: Optional[pulumi.Input[str]] = None,
            to: Optional[pulumi.Input[str]] = None,
            username: Optional[pulumi.Input[str]] = None) -> 'UserContact':
        """
        Get an existing UserContact resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enabled: Enable contact of the user in OpsGenie. Default value is true.
        :param pulumi.Input[str] method: This parameter is the contact method of user and should be one of email, sms or voice. Please note that adding mobile is not supported from API.
        :param pulumi.Input[str] to: to field is the address of given method.
        :param pulumi.Input[str] username: The username for contact.(reference)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["enabled"] = enabled
        __props__["method"] = method
        __props__["to"] = to
        __props__["username"] = username
        return UserContact(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Enable contact of the user in OpsGenie. Default value is true.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def method(self) -> pulumi.Output[str]:
        """
        This parameter is the contact method of user and should be one of email, sms or voice. Please note that adding mobile is not supported from API.
        """
        return pulumi.get(self, "method")

    @property
    @pulumi.getter
    def to(self) -> pulumi.Output[str]:
        """
        to field is the address of given method.
        """
        return pulumi.get(self, "to")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[str]:
        """
        The username for contact.(reference)
        """
        return pulumi.get(self, "username")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

